#pragma once

#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <queue>

#include <memory>
#include <mutex>
// #include <shared_mutex>
#include <thread>

#include <algorithm>
#include <chrono>
#include <numeric>

#include <cstdint>

// #include <opencv2/opencv.hpp>

#include <Eigen/Dense>

#include <sophus/se3.hpp>

#include <gflags/gflags.h>
#include <glog/logging.h>

#include <fmt/core.h>
#include <fmt/format.h>
#include <fmt/ostream.h>

#include "eigen_stl_types.h"
#include "eigen_types.h"

// #include <aslam/cameras/camera.h>

#include <pcl/point_cloud.h>
#include <pcl/point_types.h>

#include <ros/ros.h>

#include <Open3D/Open3D.h>

#include <pcl/features/fpfh.h>
#include <pcl/features/fpfh_omp.h>
#include <pcl/features/normal_3d.h>

namespace xreg {

using SE3 = Sophus::SE3d;
using SO3 = Sophus::SO3d;

using pcl::PointXYZ;
using pcl::Normal;

using PointCloudXYZ = pcl::PointCloud<pcl::PointXYZ>;

using CloudFPFH = pcl::PointCloud<pcl::FPFHSignature33>;
using CloudNormal = pcl::PointCloud<pcl::Normal>;

#define INFOLOG(args...) LOG(INFO) << fmt::format(args);

#define WARNLOG(args...) LOG(WARNING) << fmt::format(args);

#define ERRLOG(args...) LOG(ERROR) << fmt::format(args);

#define FATALLOG(args...) LOG(FATAL) << fmt::format(args);

} // namespace xreg