#pragma once

#include <string>

#include <ros/ros.h>

namespace xreg {

enum BA_WEIGHT { CONSTANT, LOCAL, LOCAL_GLOBAL };
enum BA_LOSS { NONE, LCONSTANT, SCALAR_DEPEND };

namespace ba {

extern int idx_ba_init;

extern bool b_map_check_num;
extern int th_map_min_num;
extern bool b_map_check_min_lambda;
extern double th_map_min_lambda;
extern bool b_map_check_max_lambda;
extern double th_map_max_lambda;
extern bool b_map_check_p2;
extern double th_map_p2;

// extern bool b_ba_fix_first;
extern int th_ba_min_num_frames_cell;

extern BA_WEIGHT ba_weight_type;
extern BA_LOSS ba_loss_type;
extern double ba_loss_ratio_trans;
extern double ba_loss_ratio_rot;
// extnrn bool b_use

}  // namespace test_ba

namespace common {

extern std::string data_path;
extern std::string dataset;
extern std::string log_path;

extern std::string method;

extern bool b_init;
extern std::string init_method;
extern std::string init_traj_path;

extern int num_knn;

extern double resolution;

extern double corr_dist;

extern int num_threads;

extern int search_method;

extern bool perform_downsample;

extern float downsample_resolution;

extern int frame_idx;

extern double overlap_ratio;

}  // namespace common

namespace feature {

extern double resolution_downsample;
extern double resolution_normal;
extern double resolution_keypoints;
extern double resolution_fpfh;

extern bool b_match_all_pairs;

}  // namespace feature

namespace reg {
extern bool b_scan2map;
extern bool b_fix_first;
extern int num_iteration;

extern bool b_downsample;
extern double resolution_downsample;
// extern double b;
}  // namespace reg

namespace tpp {

extern double noise_bound;

extern double cbar2;

extern double gnc_factor;

extern bool b_pgo;
}  // namespace tpp

namespace balm {

extern int window_size;
extern int marg_size;

extern double voxel_size;
}  // namespace balm

void initParameters(ros::NodeHandle &nh);

}  // namespace xreg
