#pragma once

#include "registration_base.h"

#include "xreg/types/voxel.h"

namespace xreg {

class RegistrationEigenFactor : public RegistrationBase {
public:
  EIGEN_MAKE_ALIGNED_OPERATOR_NEW

  RegistrationEigenFactor(/* args */);

  virtual ~RegistrationEigenFactor() = default;

  void scanToMap(Frame::Ptr frame_src);

  void registration() override;

  void initialize() override;

  void mapBA(size_t curr_idx);

public:
  bool initialized_ = false;
  std::unique_ptr<VoxelMapOctree> voxel_map_ = nullptr;

  // std::vector<
  eigen_aligned_std_vector<SE3> Tlb_;

  // std::unique_ptr
  /* data */
};

} // namespace xreg