#pragma once

#include "registration_base.h"

#include "xreg/types/voxel.h"

#include "balm/balmclass.hpp"

namespace xreg {

using namespace balm;

class RegistrationBALM : public RegistrationBase {
 public:
  EIGEN_MAKE_ALIGNED_OPERATOR_NEW

  RegistrationBALM(/* args */);

  virtual ~RegistrationBALM() = default;

  // void scanToScan(Frame::Ptr frame_src, Frame::Ptr frame_tgt);

  // void scanToMap(Frame::Ptr frame_src);

  void registration() override;

  void initialize() override;

  // void mapBA(size_t curr_idx);

  void cut_voxel(
      std::unordered_map<VOXEL_LOC, OCTO_TREE *, VLocHash, VLocEqual> &feat_map,
      pcl::PointCloud<PointType>::Ptr pl_feat, Eigen::Matrix3d R_p,
      Eigen::Vector3d t_p, int feattype, int fnum, int capacity);

 public:
  bool initialized_ = false;
  // std::unique_ptr<VoxelMapOctree> voxel_map_ = nullptr;

  // std::vector<
  eigen_aligned_std_vector<SE3> Tlb_;

  // double surf_filter_length = 0.2;
  // double corn_filter_length = 0.2;

  int window_size = 20;
  int margi_size = 5;

  int filter_num = 1;
  int thread_num = 1;
  int skip_num = 0;
  int pub_skip = 1;

  // std::unique_ptr
  /* data */
};

}  // namespace xreg