#pragma once

#include "registration_base.h"

#include <pcl/point_types.h>

#include <pcl/registration/registration.h>

namespace xreg {

class RegistrationICPPlane : public RegistrationBase {
 public:
  EIGEN_MAKE_ALIGNED_OPERATOR_NEW

  void initialize() override;

  RegistrationICPPlane(/* args */);

  virtual ~RegistrationICPPlane() = default;

  void registration() override;

  // void initialize() override;
  template <typename PT>
  void scan2scan(pcl::Registration<PT, PT> *reg);

  template <typename PT>
  void scan2map(pcl::Registration<PT, PT> *reg);

 public:
  // std::vector<Frame::Ptr> frames;
  eigen_aligned_std_vector<SE3> Tlb_;
  /* data */
};

template <>
void RegistrationICPPlane::scan2scan(
    pcl::Registration<pcl::PointXYZRGBNormal, pcl::PointXYZRGBNormal> *reg);

template <>
void RegistrationICPPlane::scan2map(
    pcl::Registration<pcl::PointXYZRGBNormal, pcl::PointXYZRGBNormal> *reg);

}  // namespace xreg