#pragma once

#include "registration_base.h"

#include "xreg/types/voxel.h"

namespace xreg {

struct TeaserOptions {
  bool b_adj_only = true;
};

class RegistrationTeaser : public RegistrationBase {
public:
  EIGEN_MAKE_ALIGNED_OPERATOR_NEW

  explicit RegistrationTeaser(TeaserOptions options);

  virtual ~RegistrationTeaser() = default;

  void registration() override;

  static SE3 registerByTeaser(pcl::PointCloud<pcl::PointXYZ>::Ptr &kps0,
                              pcl::PointCloud<pcl::PointXYZ>::Ptr &kps1,
                              // pcl::CorrespondencesPtr &corr
                              const std::vector<std::pair<int, int>> &corr);

  void optimizePoseGraph();

  // void initialize() override;

public:
  TeaserOptions options_;

  eigen_aligned_std_vector<SE3> relative_poses_;
  // std::unique_ptr<VoxelMapOctree> voxel_map_ = nullptr;

  // std::unique_ptr
  /* data */
};

} // namespace xreg