#pragma once

#include <ceres/ceres.h>

#include "se3_param.hpp"

namespace xreg {

class RotationFactor : public ceres::SizedCostFunction<3, 3, 3> {
public:
  EIGEN_MAKE_ALIGNED_OPERATOR_NEW

public:
  explicit RotationFactor(const SO3 &rot_ji);

  virtual bool Evaluate(double const *const *parameters, double *residuals,
                        double **jacobians) const override;

public:
  // const Vector3d mu_;
  SO3 rot_ji_;
};

class TranslationFactor : public ceres::SizedCostFunction<3, 3, 3, 3> {
public:
  EIGEN_MAKE_ALIGNED_OPERATOR_NEW

public:
  explicit TranslationFactor(const SE3 &Tji);

  virtual bool Evaluate(double const *const *parameters, double *residuals,
                        double **jacobians) const override;

public:
  // const Vector3d mu_;
  SE3 Tji_;
};
} // namespace xreg
