#pragma once

#include "common/common.h"

#include "types/frame.hpp"

#include "visualization/visualizer.h"

#include "estimation/registration_base.h"

#include "xreg/estimation/registration_ba.h"

namespace xreg {
class TestScan2Scan {
public:
  explicit TestScan2Scan(ros::NodeHandle nh);

  ~TestScan2Scan() = default;

  void loadFrames(const std::string &file_path);

  void visualize();

  void visualizeIdx();

  void spin();

  void shutdown();

  void downsample(PointCloudXYZ::Ptr cloud, PointCloudXYZ::Ptr cloud_filtered,
                  double size);

  void summarize(double time);

public:
  ros::NodeHandle nh_;

  std::vector<Frame::Ptr> frames_;

  // RegistrationBase::Ptr registration_ = nullptr;
  RegistrationBA *registration_ = nullptr;

  std::unique_ptr<Visualizer> viewer_;
  std::unique_ptr<std::thread> thread_viz_ = nullptr;
};

} // namespace xreg
