#pragma once

#include "../common/common.h"

#include "voxel.h"

namespace xreg {

// struct FLANNPoints3d {

//   std::vector<Point3> pts;
//   inline FLANNPoints3d(const GaussianComponents &comp_) {
//     Point3 pt;
//     for (size_t i = 0; i < comp_.size(); i++) {
//       pt.x = comp_[i]->mean().x();
//       pt.y = comp_[i]->mean().y();
//       pt.z = comp_[i]->mean().z();
//       pts.push_back(pt);
//     }
//   }

//   inline size_t kdtree_get_point_count() const { return pts.size(); }

//   inline double kdtree_distance(const double *p1, const size_t idx_p2,
//                                 size_t /*size*/) const {
//     const double d0 = p1[0] - pts[idx_p2].x;
//     const double d1 = p1[1] - pts[idx_p2].y;
//     const double d2 = p1[2] - pts[idx_p2].z;
//     return d0 * d0 + d1 * d1 + d2 * d2;
//   }

//   inline double kdtree_get_pt(const size_t idx, const size_t dim) const {
//     if (dim == 0)
//       return pts[idx].x;
//     else if (dim == 1)
//       return pts[idx].y;
//     else
//       return pts[idx].z;
//   }

//   template <class BBOX> bool kdtree_get_bbox(BBOX & /* bb */) const {
//     return false;
//   }
// };

class BlockKDTree {
public:
  using Ptr = std::shared_ptr<Block>;

  using ConstPtr = std::shared_ptr<const Block>;

public:
  EIGEN_MAKE_ALIGNED_OPERATOR_NEW

  Block) = delete;

  Block(double block_size, Vector3d origin)
      : block_size_(block_size), block_size_inv_(1.0 / block_size),
        origin_(origin) {

    VoxelIndex voxel_idx =
        getGridIndexFromPoint<VoxelIndex>(origin * block_size_inv_);
    idx_ = AnyIndexHash()(voxel_idx);

    initOctree();
  }

  ~Block() = default;

  void initOctree();

  //   size_t countComponents() { return components_.size(); }

public:
  size_t idx_ = 0; // hash index

  double block_size_, block_size_inv_;

  Vector3d origin_;

  OctreeNode::Ptr octree_ = nullptr;

  // list<Cell *> cell_cache_;
};

} // namespace xreg
