#pragma once

#include "../common/common.h"

namespace xreg {

class MathUtils {
public:
  static Matrix3d skew(const Vector3d &vec);

  //   static Matrix3d computeEssentialMatrix(const SE3Quat &Tcw1,
  //                                          const SE3Quat &Tcw2

  //   );

  //   static Matrix3d computeFundamentalMatrix(const SE3Quat &Tcw1,
  //                                            const Matrix3d &K1,
  //                                            const SE3Quat &Tcw2,
  //                                            const Matrix3d &K2

  //   );

  static Matrix3d rightJacobian(const SO3 &rot);

  static Matrix3d rightJacobian(const Vector3d &rot);

  static Matrix3d inverseRightJacobian(const Vector3d &rot);

  // static void marginalize();
  static Eigen::MatrixXd marginalize(const Eigen::MatrixXd &H, const int &start,
                                     const int &end);

  template <typename PointT> static Vector3d pcl2Eigen(const PointT &pt) {
    return Vector3d(pt.x, pt.y, pt.z);
  }
};

} // namespace xreg
