#pragma once

#include "../common/common.h"

#include <ros/ros.h>

#include <sensor_msgs/PointCloud2.h>

#include <visualization_msgs/MarkerArray.h>

#include "../types/octree.h"
#include "../types/voxel.h"

namespace xreg {

class VoxelMapVisualizer {
public:
  using Ptr = std::unique_ptr<VoxelMapVisualizer>;

  using ConstPtr = std::unique_ptr<const VoxelMapVisualizer>;

  VoxelMapVisualizer(ros::NodeHandle &nh, VoxelMapOctree::Ptr map);

  ~VoxelMapVisualizer() = default;

  void visualize();

  //   void setQueryResult(const std::vector<OctreeNode *> &nodes);

private:
  std::string topic_;
  ros::Publisher pub_, cloud_pub_;

  visualization_msgs::MarkerArray::Ptr msg_ = nullptr;

  VoxelMapOctree::Ptr map_ = nullptr;

  std::unordered_set<OctreeNode *> query_results_;
};

} // namespace xreg
