#! /usr/bin/python3

# %%

from evo.tools import file_interface
from evo.core import lie_algebra as lie
from evo.core import transformations as tr
from evo.core import metrics
# lie.

import numpy as np

import sys, os

traj_gt_path = sys.argv[1]
traj_est_path = sys.argv[2]
# traj_gt_path = "../logs/gt/"
# traj_est_path = "../logs/est_ba_0702_174608/"
# sys
# from pathlib import
names = ['apartment', 'gazebo_summer', 'gazebo_winter',
         'hauptgebaude', 'mountain', 'stairs', 'wood_autumn', 'wood_summer']

# # relative
# for fname in names:
#     print(f'\n###########################\n#####   {fname}')
#     traj_file1 = traj_gt_path + '/' + fname
#     traj_file2 = traj_est_path + '/' + fname
#     if (not os.path.isfile(traj_file1)) or (not os.path.isfile(traj_file2)):
#         continue

#     # traj_
#     traj_gt = file_interface.read_tum_trajectory_file(traj_file1)
#     traj_est = file_interface.read_tum_trajectory_file(traj_file2)
#     poses_est, poses_gt = traj_est.poses_se3, traj_gt.poses_se3

#     assert len(poses_est) == len(poses_gt)
#     rel_err_total = []
#     for i in range(len(poses_est)):
#         if i == 0:
#             continue
#         # poses_est[]
#         rel_est = lie.relative_se3(poses_est[i - 1], poses_est[i])
#         # print(rel_est)
#         rel_gt = lie.relative_se3(poses_gt[i - 1], poses_gt[i])
#         # print(rel_gt)
#         pose_err = lie.relative_se3(rel_est, rel_gt)
#         # print(pose_err)
#         terr = np.linalg.norm(pose_err[:3, 3])
#         print(f'frame {i}, terr: {terr}, ')
#         rel_err_total.append(terr)
#     print(
#         f"avg err: {np.mean(rel_err_total)}, max err: {np.max(rel_err_total)}")
print('name, rpe, ape')
error_out = []
for fname in names:
    # print(f'\n###########################\n#####   {fname}')
    traj_file1 = traj_gt_path + '/' + fname
    traj_file2 = traj_est_path + '/' + fname
    if (not os.path.isfile(traj_file1)) or (not os.path.isfile(traj_file2)):
        continue

    # traj_
    traj_gt = file_interface.read_tum_trajectory_file(traj_file1)
    traj_est = file_interface.read_tum_trajectory_file(traj_file2)

    traj_est.align(traj_gt)

    data = (traj_gt, traj_est)
    ape = metrics.APE(metrics.PoseRelation.translation_part)
    ape_rot = metrics.APE(metrics.PoseRelation.rotation_angle_deg)
    ape.process_data(data)
    ape_rot.process_data(data)
    stats = ape.get_all_statistics()
    # print(f"mean: {stats['mean']}, rmse: {stats['rmse']}")
    # metrics.Metric
    poses_est, poses_gt = traj_est.poses_se3, traj_gt.poses_se3

    # assert len(poses_est) == len(poses_gt)
    rel_err_total = []
    for i in range(len(poses_est)):
        if i == 0:
            continue
        # poses_est[]
        rel_est = lie.relative_se3(poses_est[i - 1], poses_est[i])
        # print(rel_est)
        rel_gt = lie.relative_se3(poses_gt[i - 1], poses_gt[i])
        # print(rel_gt)
        pose_err = lie.relative_se3(rel_est, rel_gt)
        # print(pose_err)
        terr = np.linalg.norm(pose_err[:3, 3])
        # print(f'frame {i}, terr: {terr}, ')
        rel_err_total.append(terr)
    # print(
    #     f"avg err: {np.mean(rel_err_total)}, max err: {np.max(rel_err_total)}")
    err_arr = ape.get_result().np_arrays['error_array']
    # print(err_arr)
    ape_mean = stats['mean']
    ape_rot_mean = ape_rot.get_all_statistics()['mean']
    print(f'{fname}, {np.mean(rel_err_total)}, {ape_mean}, {ape_rot_mean}')
    # error_out.append(np.mean(rel_err_total))
    error_out.append(ape_mean)
print(error_out)
# for zip(poses_gt, pose)

# %%
