# %%
#! /usr/bin/python3

import open3d as o3d

from pathlib import Path
import glob

import numpy as np
import csv

import copy

import matplotlib.cm as cm

# print(cm.hot(0.3))

base_path = "/home/hyhuang/Data/ethz_registration/"
dataset = "mountain"

data_path = Path(base_path) / dataset
pcd_path = data_path / "pcd"


def read_pc_poses(file_name):
    reader = csv.reader(open(file_name, 'r'))
    rows = [row for row in reader]
    rows = rows[1:]

    Tgt = [np.array(list(map(float, row[1:]))).reshape(4, 4) for row in rows]

    return len(Tgt), Tgt
    # pass

num_pcd, Tgt = read_pc_poses(data_path / "icpList.csv")

pcd_data = [o3d.io.read_point_cloud(
    f'{str(pcd_path / str(i))}.pcd') for i in range(num_pcd)]
pcd_gt = [p.transform(T) for (p, T) in zip(pcd_data, Tgt)]

# from tqdm import tqdm
def color_all(pcds):
    for i in range(len(pcds)):
        c = list(cm.jet(i / len(pcds))[:-1])
        colors = [c for x in range(len(pcds[i].points))]
        pcds[i].colors = o3d.utility.Vector3dVector(colors)

def color_selected(pcds, inds):
    for i in inds:
        c = np.random.rand(3)
        colors = [c for x in range(len(pcds[i].points))]
        pcds[i].colors = o3d.utility.Vector3dVector(colors)

# maybe voxel in common?
inds = range(len(pcd_gt))
color_selected(pcd_gt, inds)
o3d.visualization.draw_geometries([pcd_gt[i] for i in inds])


# Tgt[]

# pcd_files = glob.glob(pcd_path, "*.pcd")
# pcd_files = list(pcd_path.glob("*.pcd"))
# pcd_files.sort()

# def read_gt():

# vis0 = o3d.Visualizer()
# vis0.create_window(window_name='global', width=960, height=540, left=0, top=0)
# for pcd in pcd_data:
#     vis0.add_geometry(pcd)

# while True:
#     vis0.update_geometry()
#     if not vis0.poll_events():
#         break
#     vis0.update_renderer()
# vis0.
# vis0.cre
# for p in pcd_data:
# o3d.visualization.draw_geometries(pcd_data)


# pcd =
# pcd = o3d.io.read_point_cloud(str(pcd_path / "0.pcd"))
# print(pcd)
# print(np.asarray(pcd.points))
# o3d.visualization.draw_geometries([pcd])

# %%
