#%%
#! /usr/bin/python3

# import open3d as o3d

from pathlib import Path
import glob

import numpy as np
import csv

# import copy
# import evo

from evo.core import transformations as tr

base_path = "/home/hyhuang/Data/ethz_registration/"
dataset = "wood_summer"
# hauptgebaude  mountain  stairs  wood_autumn  wood_summer

data_path = Path(base_path) / dataset
pcd_path = data_path / "pcd"


# def read_gt(file_name):
file_name = data_path / "icpList.csv"
reader = csv.reader(open(file_name, 'r'))
# reader.
rows = [row for row in reader]
rows = rows[1:]
# map(float, )
Tgt = [np.array(list(map(float, row[1:]))).reshape(4, 4) for row in rows]

qs = [tr.quaternion_from_matrix(T) for T in Tgt]
ts = [T[:3, 3] for T in Tgt]

with open(data_path / 'gt', 'w') as ofs:
    for idx, (t, q) in enumerate(zip(ts, qs)):
        ofs.write(f'{idx} {t[0]} {t[1]} {t[2]} {q[1]:.09f} {q[2]:.09f} {q[3]:.09f} {q[0]:.09f}\n')
        pass

# %%
