#! /bin/bash
# source .utils.sh
trap ctrl_c INT

DATAPATH=/home/hyhuang/Data/ethz_registration/
# DATASET=wood_autumn
# DATASET=stairs
# DATASET=apartment
# DATASET=mountain
DATASET=wood_summer
RESOLUTION=0.4
# RESOLUTION=(0.05 0.1 0.2 0.3 0.4 0.5 0.6)
OVERLAP=1.5
METHOD=ba
NUM_THREADS=10
SEARCH=0
DRES=0.5
IDX=10

function ctrl_c() {
    kill %1
    exit
}

function srcc() {
    prefix=''
    if [ "$#" -eq 1 ]; then
        prefix="_$1"
        print $prefix
    fi

    cwd=$(pwd)
    cdir=$(pwd)
    while [ $cdir != $HOME ]; do
        dir_to_check="$cdir/devel$prefix"
        if [ -d $dir_to_check ]; then
            source "$dir_to_check/setup.bash"
            echo "source $dir_to_check/setup.bash"
            break
        fi
        cd ..
        cdir=$(pwd)
    done
    if [ $cdir = $HOME ]; then
        echo "failed to find a catkin... "
    fi

    cd $cwd
}

srcc
rosparam load `rospack find xreg`/cfg/param.yaml
# roscore &
for np in ${RESOLUTION[*]}
do
	echo $np
	# DATASET=hauptgebaude
	# RESOLUTION=0.1
	# method=gicp
	# search_method=1
	rosparam set log_path `rospack find xreg`/logs/
	rosparam set data_path $DATAPATH
	rosparam set dataset $DATASET
	rosparam set resolution $np
	rosparam set method $METHOD
	rosparam set num_threads $NUM_THREADS
	rosparam set search_method $SEARCH

	rosparam set dresolution $DRES

	rosparam set idx $IDX
	rosparam set overlap_ratio $OVERLAP

	rosrun xreg xreg_node
done
