#! /bin/bash
script_dir=$(dirname $0)
source $script_dir/utils.sh

# DATAPATH
# DATAPATH=/mnt/data0/Data/ethz_registration/
DATAPATH=/home/hyhuang/Data/ethz_registration/
DATASET=(apartment gazebo_summer gazebo_winter hauptgebaude mountain stairs wood_autumn wood_summer)
# DATASET=(gazebo_summer hauptgebaude wood_autumn)
# DATASET=(apartment)
# res_down=

srcc
base_dir=$(rospack find xreg)

# xm=balm
xm=ba
rosparam load $(rospack find xreg)/cfg/param.yaml
rosparam set log_path $(rospack find xreg)/logs/
rosparam set init_traj_path $(rospack find xreg)/data/init_teaser
# rosparam set init_traj_path $(rospack find xreg)/logs/est_teaser_0507_113236
rosparam set data_path $DATAPATH
rosparam set method $xm
rosparam set num_threads 7
# rosparam set resolution 0.4

touch $base_dir/logs/est/timing

# roscore &
mkdir $base_dir/logs/est
for dset in ${DATASET[*]}; do
    echo "########## $dset"

    rosparam set dataset $dset
    # rm -rf $base_dir/logs/est

    rosrun xreg xreg_node
    mv $base_dir/logs/traj $base_dir/logs/est/$dset
done

# cp $base_dir/cfg/param.yaml $base_dir/logs/est/
rosparam dump $base_dir/logs/est/param.yaml
rand_su=$(
    tr -dc a-z0-9 </dev/urandom | head -c 6
    echo ''
)
sufix=`date +"%m%d_%H%M%S"`
# xm=`rosparam get /method`
outpath=$base_dir/logs/est_"$xm"_"$sufix"
mv $base_dir/logs/est $outpath

# echo $rand_su
echo "result save to $outpath"

echo "a" | sendmail hyhuang1995@foxmail.com
