# %%
#! /usr/bin/python3

import open3d as o3d

from pathlib import Path
import glob

import numpy as np
import csv

from evo.tools import file_interface

import copy

import matplotlib.cm as cm
import matplotlib.pyplot as plt

import pickle

# with open('/home/hyhuang/rosWorkSpace/xreg/src/xreg/data/result/ba/trans.pkl', 'rb') as ifs:
#     a = pickle.load(ifs)
def read_pc_poses(file_name):
    reader = csv.reader(open(file_name, 'r'))
    rows = [row for row in reader]
    rows = rows[1:]

    Tgt = [np.array(list(map(float, row[1:]))).reshape(4, 4) for row in rows]

    return len(Tgt), Tgt
    # pass

base_path = "/home/hyhuang/Data/ethz_registration/"
datasets = ["apartment", "gazebo_summer", "gazebo_winter",
            "hauptgebaude", "mountain", "stairs", "wood_autumn", "wood_summer"]

log_path = Path(
    "/home/hyhuang/rosWorkSpace/xreg/src/xreg/data/result/")
methods = [f for f in log_path.iterdir()]


dconcat = {}
dconcat_m = {}
for method_path in methods:
    mname = str(method_path).split('/')[-1]
    print('###### ', mname)

    # load transform
    # #     res = {}
    with open(method_path / 'dist.pkl', 'rb') as ofs:
        dist_dict = pickle.load(ofs)
    dconcat[mname] = np.concatenate(list(dist_dict.values()))
    
   
mnames = dconcat.keys()
# for mname in mnames:
plt.boxplot(dconcat.values(), showfliers=False)
ax = plt.gca()
ax.set_xticklabels(mnames)
# ax.set_yscale('log')

plt.show()


# %%
