#include "xreg/optimization/factors_ef.h"

#include "xreg/common/common.h"

using namespace xreg;
using namespace std;

int main(int argc, char **argv) {
  /* code */
  //   Eigen::Ve
  srand((unsigned int)time(0));
  Vector4d qi_coef = Vector4d::Random().normalized();
  Quaterniond qi(qi_coef);

  Vector3d ti = Vector3d::Random();
  Vector4d pi = Vector4d::Random().normalized();

  SE3 Ti(qi, ti);
  Vector6d Ti_log = Ti.log();

  Cell *cell = new Cell;
  cell->pi_ = pi;

  Eigen::Matrix4d Q = Eigen::Matrix4d::Random();
  Eigen::Matrix4d lt = Q.llt().matrixLLT();

  {
    cout << "?" << endl;
    ceres::CostFunction *factor = new EigenFactorSQR(lt, cell);
    cout << "?" << endl;
    double *params[1];
    double *jacob_arr[1];

    Vector4d residual;
    Eigen::Matrix<double, 4, 6, Eigen::RowMajor> jacob, jacob_num;

    params[0] = Ti_log.data();
    jacob_arr[0] = jacob.data();

    constexpr double eps = 1e-6;
    factor->Evaluate(params, residual.data(), jacob_arr);

    // STEP. rot 2 roti
    for (size_t i = 0; i < 6; i++) {
      Vector4d res_tmp;
      Vector6d delta_rot = Vector6d::Zero();
      delta_rot[i] += eps;
      // Ti_log = (Ti * SE3::exp(delta_rot)).log();
      Ti_log = (SE3::exp(delta_rot) * Ti).log();

      factor->Evaluate(params, res_tmp.data(), nullptr);
      jacob_num.col(i) = (res_tmp - residual) / eps;
      // cout << res_tmp.transpose() << endl;
    }

    INFOLOG("mat:\n{}\n\n{}", jacob, jacob_num);
    CHECK_LE((jacob - jacob_num).sum(), eps);
  }
  return 0;
}